#copy_change_dur.py
#this script will append to an item a duplicate of this item with the duration amended by the ratio.
#it was made possible through the FluCoMa project (European Union’s Horizon 2020 research and innovation programme, grant #725899)

#copy rall, asks the user for a duration
ratio_stretch_input = RPR_GetUserInputs("Copy and Change Duration", 1, "Enter a ratio for the new duration:", "", 512)[4]
times_input = RPR_GetUserInputs("Copy and Change Duration", 1, "Enter the number of times this process should happen:", "", 512)[4]

if ratio_stretch_input != "":
    ratio_stretch = float(ratio_stretch_input)
    times = int(times_input)
    #counts the selection
    item_count = RPR_CountSelectedMediaItems( 0 )

    #iterate through the selected items to make a list of pointers
    items = []
    for x in range(item_count):
        item = RPR_GetSelectedMediaItem( 0, x )
        items.append(item)

    for item in items:
        for x in range(times):
            #do it as many times as requested
            #finds the item's duration and its take's start offset
            duration = RPR_GetMediaItemInfo_Value(item, "D_LENGTH")
            start_time = RPR_GetMediaItemInfo_Value(item, "D_POSITION")
            start_offset =  RPR_GetMediaItemTakeInfo_Value(RPR_GetActiveTake(item), "D_STARTOFFS")

            # stretch the item, cuts it back, deselects it, then offsets the start of the new item
            RPR_SetMediaItemInfo_Value(item, "D_LENGTH", (duration * (1+ratio_stretch)))
            new_item = RPR_SplitMediaItem(item, (duration + start_time))
            RPR_SetMediaItemSelected( item, False )
            if new_item == 'NULL':
                 RPR_ShowConsoleMsg("Error Splitting\n")
                 break
            else:
                RPR_SetMediaItemTakeInfo_Value(RPR_GetActiveTake(new_item), "D_STARTOFFS", start_offset)
                item = new_item

    #updates
    RPR_UpdateArrange()
