#show_in_finder.py
#this script will show the selected item's active take's in the finder
#it was made possible through the FluCoMa project (European Union’s Horizon 2020 research and innovation programme, grant #725899)

#inspired and helped by this references
#https://forum.cockos.com/showthread.php?t=147079

import sys
import subprocess

#hack to force the string type to be unicode if sys is not 3:
native_encode = sys.getdefaultencoding()
if native_encode == 'ascii':
    reload(sys)
    sys.setdefaultencoding('UTF8')

#get the number of selections
nb_of_sel = RPR_CountSelectedMediaItems(0)

for item_number in range(nb_of_sel):
    #get the item's active take's source's filepath
    item = RPR_GetSelectedMediaItem( 0, item_number )
    active_take = RPR_GetActiveTake(item)
    source = RPR_GetMediaItemTake_Source(active_take)
    result = RPR_GetMediaSourceFileName(source, "", 512)[1]

    # switches for mac or windows command to reveal
    if sys.platform == 'darwin':
        # calls the shell command to open (reveal) in finder
        subprocess.call(["open", "-R", result])
    else:
        subprocess.call(["explorer", "/select,", result])

#cleans the hack mess
if native_encode == 'ascii':
    reload(sys)
    sys.setdefaultencoding(native_encode)
