#shuffler.py
#this script will shuffle contiguous items on a single track
#it was made possible through the FluCoMa project (European Union’s Horizon 2020 research and innovation programme, grant #725899)

from random import shuffle

#check the track count is one
if RPR_CountSelectedTracks(0) != 1:
    RPR_ShowConsoleMsg("too many lines\n")
else:
#check the items are contiguous and non-overlapping
    item_count = RPR_CountSelectedMediaItems( 0 )
    total_duration = 0
    items = []
    #iterate through the lenghts
    for x in range(item_count):
        item = RPR_GetSelectedMediaItem( 0, x )
        items.append(item)
        total_duration +=  RPR_GetMediaItemInfo_Value(item, "D_LENGTH")

    first_start = RPR_GetMediaItemInfo_Value(items[0], "D_POSITION")
    last_start = RPR_GetMediaItemInfo_Value(item, "D_POSITION")
    last_end = last_start + RPR_GetMediaItemInfo_Value(item, "D_LENGTH")

    #sum of durations should be
    if first_start + total_duration != last_end:
        RPR_ShowConsoleMsg("not contiguous\n")
    else:
        #make a new order
        shuffle(items)
        current_position = first_start
        #assign the new position
        for item in items:
            RPR_SetMediaItemInfo_Value(item, "D_POSITION", current_position)
            dur = RPR_GetMediaItemInfo_Value(item, "D_LENGTH")
#            RPR_ShowConsoleMsg(str(item) + " " + str(current_position) + " " + str(dur) + "\n")
            current_position +=  dur
        #resets the window
        RPR_UpdateArrange()
